{-# LANGUAGE EmptyDataDecls, RankNTypes, ScopedTypeVariables #-}

module Ta where {

import qualified Nat;
import qualified Array;
import qualified Natural;

data Numa = One | Bit0 Numa | Bit1 Numa deriving (Read, Show);

data Color = R | B deriving (Read, Show);

data Rbta a b = Empty | Branch Color (Rbta a b) a b (Rbta a b)
  deriving (Read, Show);

class Orda a where {
  less_eq :: a -> a -> Bool;
  less :: a -> a -> Bool;
};

class (Orda a) => Preorder a where {
};

class (Preorder a) => Order a where {
};

class (Order a) => Linorder a where {
};

newtype (Linorder a) => Rbt a b = Rbt (Rbta a b) deriving (Read, Show);

data Ta_rule a b = Rule a b [a] deriving (Read, Show);

lhs :: forall a b. Ta_rule a b -> a;
lhs (Rule q l qs) = q;

hd :: forall a. [a] -> a;
hd (x : xs) = x;

tl :: forall a. [a] -> [a];
tl [] = [];
tl (x : xs) = xs;

suc :: Nat.Nat -> Nat.Nat;
suc n = n + 1;

rhsl :: forall a b. Ta_rule a b -> b;
rhsl (Rule q l qs) = l;

rhsq :: forall a b. Ta_rule a b -> [a];
rhsq (Rule q l qs) = qs;

data Ustate_wrapper a b = USW1 a | USW2 b deriving (Read, Show);

data Tree a = Node a [Tree a] deriving (Read, Show);

data Itself a = Type deriving (Read, Show);

empty :: forall a b. (Linorder a) => Rbt a b;
empty = Rbt Empty;

r_prod :: forall a b c d. Ta_rule a b -> Ta_rule c d -> Ta_rule (a, c) b;
r_prod (Rule q1 l1 qs1) (Rule q2 l2 qs2) = Rule (q1, q2) l1 (zip qs1 qs2);

newtype Dlist a = Dlist [a] deriving (Read, Show);

foldla :: forall a b. (a -> b -> a) -> a -> [b] -> a;
foldla f a [] = a;
foldla f a (x : xs) = foldla f (f a x) xs;

map_of :: forall a b. (Eq a) => [(a, b)] -> a -> Maybe b;
map_of ((l, v) : ps) k = (if l == k then Just v else map_of ps k);
map_of [] k = Nothing;

instance Orda Nat.Nat where {
  less_eq = (\ a b -> a <= b);
  less = (\ a b -> a < b);
};

the :: forall a. Maybe a -> a;
the (Just x) = x;

impl_of :: forall a b. (Linorder a) => Rbt a b -> Rbta a b;
impl_of (Rbt x) = x;

paint :: forall a b. Color -> Rbta a b -> Rbta a b;
paint c Empty = Empty;
paint c (Branch uu l k v r) = Branch c l k v r;

balance :: forall a b. Rbta a b -> a -> b -> Rbta a b -> Rbta a b;
balance (Branch R a w x b) s t (Branch R c y z d) =
  Branch R (Branch B a w x b) s t (Branch B c y z d);
balance (Branch R (Branch R a w x b) s t c) y z Empty =
  Branch R (Branch B a w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch R a w x b) s t c) y z (Branch B va vb vc vd) =
  Branch R (Branch B a w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R Empty w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance (Branch R (Branch B va vb vc vd) w x (Branch R b s t c)) y z Empty =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch R Empty w x (Branch R b s t c)) y z (Branch B va vb vc vd) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch R (Branch B ve vf vg vh) w x (Branch R b s t c)) y z
  (Branch B va vb vc vd) =
  Branch R (Branch B (Branch B ve vf vg vh) w x b) s t
    (Branch B c y z (Branch B va vb vc vd));
balance Empty w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z d);
balance (Branch B va vb vc vd) w x (Branch R b s t (Branch R c y z d)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z d);
balance Empty w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z Empty);
balance Empty w x (Branch R (Branch R b s t c) y z (Branch B va vb vc vd)) =
  Branch R (Branch B Empty w x b) s t (Branch B c y z (Branch B va vb vc vd));
balance (Branch B va vb vc vd) w x (Branch R (Branch R b s t c) y z Empty) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t (Branch B c y z Empty);
balance (Branch B va vb vc vd) w x
  (Branch R (Branch R b s t c) y z (Branch B ve vf vg vh)) =
  Branch R (Branch B (Branch B va vb vc vd) w x b) s t
    (Branch B c y z (Branch B ve vf vg vh));
balance Empty s t Empty = Branch B Empty s t Empty;
balance Empty s t (Branch B va vb vc vd) =
  Branch B Empty s t (Branch B va vb vc vd);
balance Empty s t (Branch v Empty vb vc Empty) =
  Branch B Empty s t (Branch v Empty vb vc Empty);
balance Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty) =
  Branch B Empty s t (Branch v (Branch B ve vf vg vh) vb vc Empty);
balance Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi)) =
  Branch B Empty s t (Branch v Empty vb vc (Branch B vf vg vh vi));
balance Empty s t (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi))
  = Branch B Empty s t
      (Branch v (Branch B ve vj vk vl) vb vc (Branch B vf vg vh vi));
balance (Branch B va vb vc vd) s t Empty =
  Branch B (Branch B va vb vc vd) s t Empty;
balance (Branch B va vb vc vd) s t (Branch B ve vf vg vh) =
  Branch B (Branch B va vb vc vd) s t (Branch B ve vf vg vh);
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty) =
  Branch B (Branch B va vb vc vd) s t (Branch v Empty vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v (Branch B vi vj vk vl) vf vg Empty)
  = Branch B (Branch B va vb vc vd) s t
      (Branch v (Branch B vi vj vk vl) vf vg Empty);
balance (Branch B va vb vc vd) s t (Branch v Empty vf vg (Branch B vj vk vl vm))
  = Branch B (Branch B va vb vc vd) s t
      (Branch v Empty vf vg (Branch B vj vk vl vm));
balance (Branch B va vb vc vd) s t
  (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm)) =
  Branch B (Branch B va vb vc vd) s t
    (Branch v (Branch B vi vn vo vp) vf vg (Branch B vj vk vl vm));
balance (Branch v Empty vb vc Empty) s t Empty =
  Branch B (Branch v Empty vb vc Empty) s t Empty;
balance (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty =
  Branch B (Branch v Empty vb vc (Branch B ve vf vg vh)) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty =
  Branch B (Branch v (Branch B vf vg vh vi) vb vc Empty) s t Empty;
balance (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t Empty
  = Branch B (Branch v (Branch B vf vg vh vi) vb vc (Branch B ve vj vk vl)) s t
      Empty;
balance (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd) =
  Branch B (Branch v Empty vf vg Empty) s t (Branch B va vb vc vd);
balance (Branch v Empty vf vg (Branch B vi vj vk vl)) s t (Branch B va vb vc vd)
  = Branch B (Branch v Empty vf vg (Branch B vi vj vk vl)) s t
      (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg Empty) s t (Branch B va vb vc vd)
  = Branch B (Branch v (Branch B vj vk vl vm) vf vg Empty) s t
      (Branch B va vb vc vd);
balance (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
  (Branch B va vb vc vd) =
  Branch B (Branch v (Branch B vj vk vl vm) vf vg (Branch B vi vn vo vp)) s t
    (Branch B va vb vc vd);

rbt_ins ::
  forall a b. (Orda a) => (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_ins f k v Empty = Branch R Empty k v Empty;
rbt_ins f k v (Branch B l x y r) =
  (if less k x then balance (rbt_ins f k v l) x y r
    else (if less x k then balance l x y (rbt_ins f k v r)
           else Branch B l x (f k y v) r));
rbt_ins f k v (Branch R l x y r) =
  (if less k x then Branch R (rbt_ins f k v l) x y r
    else (if less x k then Branch R l x y (rbt_ins f k v r)
           else Branch R l x (f k y v) r));

rbt_insert_with_key ::
  forall a b. (Orda a) => (a -> b -> b -> b) -> a -> b -> Rbta a b -> Rbta a b;
rbt_insert_with_key f k v t = paint B (rbt_ins f k v t);

rbt_insert :: forall a b. (Orda a) => a -> b -> Rbta a b -> Rbta a b;
rbt_insert = rbt_insert_with_key (\ _ _ nv -> nv);

insert :: forall a b. (Linorder a) => a -> b -> Rbt a b -> Rbt a b;
insert k v t = Rbt (rbt_insert k v (impl_of t));

rbt_lookup :: forall a b. (Orda a) => Rbta a b -> a -> Maybe b;
rbt_lookup Empty k = Nothing;
rbt_lookup (Branch uu l x y r) k =
  (if less k x then rbt_lookup l k
    else (if less x k then rbt_lookup r k else Just y));

lookupa :: forall a b. (Linorder a) => Rbt a b -> a -> Maybe b;
lookupa t = rbt_lookup (impl_of t);

cart ::
  forall a b c d e.
    (a -> (b -> Bool) -> (c -> b -> b) -> b -> b) ->
      (d -> (b -> Bool) -> (e -> b -> b) -> b -> b) ->
        (() -> b) -> ((c, e) -> b -> b) -> a -> d -> b;
cart it1 it2 empty3 ins3 s1 s2 =
  it1 s1 (\ _ -> True) (\ x -> it2 s2 (\ _ -> True) (\ y -> ins3 (x, y)))
    (empty3 ());

emptya :: forall a. Dlist a;
emptya = Dlist [];

member :: forall a. (Eq a) => [a] -> a -> Bool;
member [] y = False;
member (x : xs) y = x == y || member xs y;

inserta :: forall a. (Eq a) => a -> [a] -> [a];
inserta x xs = (if member xs x then xs else x : xs);

list_of_dlist :: forall a. Dlist a -> [a];
list_of_dlist (Dlist x) = x;

insertb :: forall a. (Eq a) => a -> Dlist a -> Dlist a;
insertb x dxs = Dlist (inserta x (list_of_dlist dxs));

membera :: forall a. (Eq a) => Dlist a -> a -> Bool;
membera dxs = member (list_of_dlist dxs);

remdups :: forall a. (Eq a) => [a] -> [a];
remdups [] = [];
remdups (x : xs) = (if member xs x then remdups xs else x : remdups xs);

it_add ::
  forall a b c d.
    (a -> b -> c -> c) ->
      (d -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c) -> c -> d -> c;
it_add update iti m1 m2 = iti m2 (\ _ -> True) (\ (a, b) -> update a b) m1;

instance Preorder Nat.Nat where {
};

instance Order Nat.Nat where {
};

is_none :: forall a. Maybe a -> Bool;
is_none (Just x) = False;
is_none Nothing = True;

iti_sel ::
  forall a b c.
    (a -> (Maybe b -> Bool) ->
            (c -> Maybe b -> Maybe b) -> Maybe b -> Maybe b) ->
      a -> (c -> Maybe b) -> Maybe b;
iti_sel iti m f = iti m is_none (\ x _ -> f x) Nothing;

it_size ::
  forall a b.
    (a -> (Nat.Nat -> Bool) ->
            (b -> Nat.Nat -> Nat.Nat) -> Nat.Nat -> Nat.Nat) ->
      a -> Nat.Nat;
it_size iti s = iti s (\ _ -> True) (\ _ -> suc) 0;

remap_rule :: forall a b c. (a -> b) -> Ta_rule a c -> Ta_rule b c;
remap_rule f (Rule q l qs) = Rule (f q) l (map f qs);

class Hashable a where {
  hashcode :: a -> Nat.Nat;
  bounded_hashcode :: Nat.Nat -> a -> Nat.Nat;
  def_hashmap_size :: Itself a -> Nat.Nat;
};

list_all_zip :: forall a b. (a -> b -> Bool) -> [a] -> [b] -> Bool;
list_all_zip p [] [] = True;
list_all_zip p (a : asa) (b : bs) = p a b && list_all_zip p asa bs;
list_all_zip p (v : va) [] = False;
list_all_zip p [] (v : va) = False;

ls_memb :: forall a. (Eq a) => a -> Dlist a -> Bool;
ls_memb x l = membera l x;

newtype Assoc_list a b = Assoc_List [(a, b)] deriving (Read, Show);

newtype (Hashable a) => Hashmap a b = RBT_HM (Rbt Nat.Nat (Assoc_list a b))
  deriving (Read, Show);

data HashedTa_ext a b c =
  HashedTa_ext (Hashmap a ()) (Dlist (Ta_rule a b))
    (Maybe (Hashmap b (Dlist (Ta_rule a b))))
    (Maybe (Hashmap a (Dlist (Ta_rule a b))))
    (Maybe (Hashmap (a, b) (Dlist (Ta_rule a b)))) c
  deriving (Read, Show);

hta_idx_f ::
  forall a b c. HashedTa_ext a b c -> Maybe (Hashmap b (Dlist (Ta_rule a b)));
hta_idx_f (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  hta_idx_f;

instance Linorder Nat.Nat where {
};

rm_lookup :: forall a b. (Linorder a) => a -> Rbt a b -> Maybe b;
rm_lookup k m = lookupa m k;

impl_ofa :: forall a b. Assoc_list a b -> [(a, b)];
impl_ofa (Assoc_List x) = x;

lookupb :: forall a b. (Eq a) => Assoc_list a b -> a -> Maybe b;
lookupb al = map_of (impl_ofa al);

lm_lookup :: forall a b. (Eq a) => a -> Assoc_list a b -> Maybe b;
lm_lookup k m = lookupb m k;

lookupc ::
  forall a b.
    (Eq a, Hashable a) => a -> Rbt Nat.Nat (Assoc_list a b) -> Maybe b;
lookupc k m =
  (case rm_lookup (hashcode k) m of {
    Nothing -> Nothing;
    Just a -> lm_lookup k a;
  });

impl_of_RBT_HM ::
  forall a b. (Hashable a) => Hashmap a b -> Rbt Nat.Nat (Assoc_list a b);
impl_of_RBT_HM (RBT_HM x) = x;

hm_lookup :: forall a b. (Eq a, Hashable a) => a -> Hashmap a b -> Maybe b;
hm_lookup k hm = lookupc k (impl_of_RBT_HM hm);

idx_lookup :: forall a b c. (a -> b -> Maybe c) -> (() -> c) -> a -> b -> c;
idx_lookup mlookup tempty i m =
  (case mlookup i m of {
    Nothing -> tempty ();
    Just s -> s;
  });

ls_empty :: forall a. () -> Dlist a;
ls_empty = (\ _ -> emptya);

hl_idx_lookup ::
  forall a b. (Eq a, Hashable a) => a -> Hashmap a (Dlist b) -> Dlist b;
hl_idx_lookup = idx_lookup hm_lookup ls_empty;

hta_lookup_f ::
  forall a b c.
    (Eq a, Hashable a) => a -> HashedTa_ext b a c -> Dlist (Ta_rule b a);
hta_lookup_f f h = hl_idx_lookup f (the (hta_idx_f h));

ls_ins :: forall a. (Eq a) => a -> Dlist a -> Dlist a;
ls_ins = insertb;

it_image_filter ::
  forall a b c d.
    (a -> (b -> Bool) -> (c -> b -> b) -> b -> b) ->
      (() -> b) -> (d -> b -> b) -> (c -> Maybe d) -> a -> b;
it_image_filter iteratei1 empty2 ins2 f s =
  iteratei1 s (\ _ -> True)
    (\ x res -> (case f x of {
                  Nothing -> res;
                  Just v -> ins2 v res;
                }))
    (empty2 ());

foldli :: forall a b. [a] -> (b -> Bool) -> (a -> b -> b) -> b -> b;
foldli [] c f sigma = sigma;
foldli (x : xs) c f sigma =
  (if c sigma then foldli xs c f (f x sigma) else sigma);

dlist_iteratei :: forall a b. Dlist a -> (b -> Bool) -> (a -> b -> b) -> b -> b;
dlist_iteratei xs = foldli (list_of_dlist xs);

ls_iteratei :: forall a b. Dlist a -> (b -> Bool) -> (a -> b -> b) -> b -> b;
ls_iteratei = dlist_iteratei;

ls_image_filter :: forall a b. (Eq b) => (a -> Maybe b) -> Dlist a -> Dlist b;
ls_image_filter = it_image_filter ls_iteratei ls_empty ls_ins;

faccs ::
  forall a b c.
    (Eq a, Eq b, Hashable b) => HashedTa_ext a b c -> Tree b -> Dlist a;
faccs h (Node f ts) =
  let {
    qs = map (faccs h) ts;
  } in ls_image_filter
         (\ r ->
           let {
             (Rule _ _ qsa) = r;
           } in (if list_all_zip (\ q qa -> ls_memb qa q) qs qsa
                  then Just (lhs r) else Nothing))
         (hta_lookup_f f h);

emptyb :: forall a b. Assoc_list a b;
emptyb = Assoc_List [];

lm_empty :: forall a b. () -> Assoc_list a b;
lm_empty = (\ _ -> emptyb);

rm_update :: forall a b. (Linorder a) => a -> b -> Rbt a b -> Rbt a b;
rm_update = insert;

update_with_aux ::
  forall a b. (Eq b) => a -> b -> (a -> a) -> [(b, a)] -> [(b, a)];
update_with_aux v k f [] = [(k, f v)];
update_with_aux v k f (p : ps) =
  (if fst p == k then (k, f (snd p)) : ps else p : update_with_aux v k f ps);

update_with ::
  forall b a. (Eq a) => b -> a -> (b -> b) -> Assoc_list a b -> Assoc_list a b;
update_with v k f al = Assoc_List (update_with_aux v k f (impl_ofa al));

update :: forall a b. (Eq a) => a -> b -> Assoc_list a b -> Assoc_list a b;
update k v = update_with v k (\ _ -> v);

lm_update :: forall a b. (Eq a) => a -> b -> Assoc_list a b -> Assoc_list a b;
lm_update = update;

updatea ::
  forall a b.
    (Eq a,
      Hashable a) => a -> b -> Rbt Nat.Nat (Assoc_list a b) ->
                                 Rbt Nat.Nat (Assoc_list a b);
updatea k v m =
  let {
    hc = hashcode k;
  } in (case rm_lookup hc m of {
         Nothing -> rm_update hc (lm_update k v (lm_empty ())) m;
         Just bm -> rm_update hc (lm_update k v bm) m;
       });

hm_update ::
  forall a b. (Eq a, Hashable a) => a -> b -> Hashmap a b -> Hashmap a b;
hm_update k v hm = RBT_HM (updatea k v (impl_of_RBT_HM hm));

rm_iterateoi ::
  forall a b c. Rbta a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
rm_iterateoi Empty c f sigma = sigma;
rm_iterateoi (Branch col l k v r) c f sigma =
  (if c sigma
    then let {
           sigmaa = rm_iterateoi l c f sigma;
         } in (if c sigmaa then rm_iterateoi r c f (f (k, v) sigmaa)
                else sigmaa)
    else sigma);

rm_iterateoia ::
  forall a b c.
    (Linorder a) => Rbt a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
rm_iterateoia r = rm_iterateoi (impl_of r);

rm_iteratei ::
  forall a b c.
    (Linorder a) => Rbt a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
rm_iteratei = rm_iterateoia;

iteratei ::
  forall a b c. Assoc_list a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
iteratei al c f = foldli (impl_ofa al) c f;

lm_iteratei ::
  forall a b c. Assoc_list a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
lm_iteratei = iteratei;

iterateia ::
  forall a b c d.
    (Linorder a) => Rbt a (Assoc_list b c) ->
                      (d -> Bool) -> ((b, c) -> d -> d) -> d -> d;
iterateia m c f sigma_0 =
  rm_iteratei m c (\ (_, lm) -> lm_iteratei lm c f) sigma_0;

hm_iteratei ::
  forall a b c.
    (Hashable a) => Hashmap a b -> (c -> Bool) -> ((a, b) -> c -> c) -> c -> c;
hm_iteratei hm = iterateia (impl_of_RBT_HM hm);

hm_add ::
  forall a b. (Eq a, Hashable a) => Hashmap a b -> Hashmap a b -> Hashmap a b;
hm_add = it_add hm_update hm_iteratei;

rm_sel ::
  forall a b c. (Linorder a) => Rbt a b -> ((a, b) -> Maybe c) -> Maybe c;
rm_sel = iti_sel rm_iteratei;

lm_sel :: forall a b c. Assoc_list a b -> ((a, b) -> Maybe c) -> Maybe c;
lm_sel = iti_sel lm_iteratei;

sel ::
  forall a b c.
    (Hashable a) => Rbt Nat.Nat (Assoc_list a b) ->
                      ((a, b) -> Maybe c) -> Maybe c;
sel m f = rm_sel m (\ (_, lm) -> lm_sel lm f);

hm_sel ::
  forall a b c. (Hashable a) => Hashmap a b -> ((a, b) -> Maybe c) -> Maybe c;
hm_sel hm = sel (impl_of_RBT_HM hm);

s_ins :: forall a b c. (a -> () -> b -> c) -> a -> b -> c;
s_ins update x s = update x () s;

hs_ins :: forall a. (Eq a, Hashable a) => a -> Hashmap a () -> Hashmap a ();
hs_ins = s_ins hm_update;

s_sel ::
  forall a b c.
    (a -> ((b, ()) -> Maybe c) -> Maybe c) -> a -> (b -> Maybe c) -> Maybe c;
s_sel sel s f = sel s (\ (u, _) -> f u);

hs_sel :: forall a b. (Hashable a) => Hashmap a () -> (a -> Maybe b) -> Maybe b;
hs_sel = s_sel hm_sel;

size_list :: forall a. [a] -> Nat.Nat;
size_list [] = 0;
size_list (a : list) = size_list list + suc 0;

it_inter ::
  forall a b c d.
    (a -> (b -> Bool) -> (c -> b -> b) -> b -> b) ->
      (c -> d -> Bool) -> (() -> b) -> (c -> b -> b) -> a -> d -> b;
it_inter iteratei1 memb2 empt3 insrt3 s1 s2 =
  iteratei1 s1 (\ _ -> True) (\ x s -> (if memb2 x s2 then insrt3 x s else s))
    (empt3 ());

it_union ::
  forall a b c.
    (a -> (b -> Bool) -> (c -> b -> b) -> b -> b) ->
      (c -> b -> b) -> a -> b -> b;
it_union it ins s1 s2 = it s1 (\ _ -> True) ins s2;

iti_ball ::
  forall a b.
    (a -> (Bool -> Bool) -> (b -> Bool -> Bool) -> Bool -> Bool) ->
      a -> (b -> Bool) -> Bool;
iti_ball iti s p = iti s (\ c -> c) (\ x _ -> p x) True;

rm_empty :: forall a b. (Linorder a) => () -> Rbt a b;
rm_empty = (\ _ -> empty);

emptyc :: forall a b. (Hashable a) => () -> Rbt Nat.Nat (Assoc_list a b);
emptyc = rm_empty;

hm_empty_const :: forall a b. (Hashable a) => Hashmap a b;
hm_empty_const = RBT_HM (emptyc ());

hm_empty :: forall a b. (Hashable a) => () -> Hashmap a b;
hm_empty = (\ _ -> hm_empty_const);

hs_empty :: forall a. (Hashable a) => () -> Hashmap a ();
hs_empty = hm_empty;

lh_image_filter ::
  forall a b. (Eq b, Hashable b) => (a -> Maybe b) -> Dlist a -> Hashmap b ();
lh_image_filter = it_image_filter ls_iteratei hs_empty hs_ins;

brc_iq :: forall a b. (Eq a, Hashable a) => Dlist (Ta_rule a b) -> Hashmap a ();
brc_iq delta =
  lh_image_filter (\ r -> (if null (rhsq r) then Just (lhs r) else Nothing))
    delta;

hta_Qi :: forall a b c. HashedTa_ext a b c -> Hashmap a ();
hta_Qi (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  hta_Qi;

mod_nat :: Nat.Nat -> Nat.Nat -> Nat.Nat;
mod_nat m n = snd (divMod m n);

fifo_empty :: forall a. () -> ([a], [a]);
fifo_empty = (\ _ -> ([], []));

s_memb :: forall a b c. (a -> b -> Maybe c) -> a -> b -> Bool;
s_memb lookupa x s = not (is_none (lookupa x s));

hs_memb :: forall a. (Eq a, Hashable a) => a -> Hashmap a () -> Bool;
hs_memb = s_memb hm_lookup;

s_iteratei ::
  forall a b c.
    (a -> (b -> Bool) -> ((c, ()) -> b -> b) -> b -> b) ->
      a -> (b -> Bool) -> (c -> b -> b) -> b -> b;
s_iteratei it s c f = it s c (\ x -> f (fst x));

hs_iteratei ::
  forall a b.
    (Hashable a) => Hashmap a () -> (b -> Bool) -> (a -> b -> b) -> b -> b;
hs_iteratei = s_iteratei hm_iteratei;

hs_size :: forall a. (Hashable a) => Hashmap a () -> Nat.Nat;
hs_size = it_size hs_iteratei;

ls_ball :: forall a. Dlist a -> (a -> Bool) -> Bool;
ls_ball = iti_ball ls_iteratei;

ls_size :: forall a. Dlist a -> Nat.Nat;
ls_size = it_size ls_iteratei;

rs_iteratei ::
  forall a b.
    (Linorder a) => Rbt a () -> (b -> Bool) -> (a -> b -> b) -> b -> b;
rs_iteratei = s_iteratei rm_iteratei;

rs_size :: forall a. (Linorder a) => Rbt a () -> Nat.Nat;
rs_size = it_size rs_iteratei;

equal_ta_rule :: forall a b. (Eq a, Eq b) => Ta_rule a b -> Ta_rule a b -> Bool;
equal_ta_rule (Rule qa la lista) (Rule q l list) =
  qa == q && la == l && lista == list;

instance (Eq a, Eq b) => Eq (Ta_rule a b) where {
  a == b = equal_ta_rule a b;
};

ball_disjoint ::
  forall a b c d. (a -> (b -> Bool) -> c) -> (b -> d -> Bool) -> a -> d -> c;
ball_disjoint ball1 memb2 s1 s2 = ball1 s1 (\ x -> not (memb2 x s2));

lh_disjoint :: forall a. (Eq a, Hashable a) => Dlist a -> Hashmap a () -> Bool;
lh_disjoint = ball_disjoint ls_ball hs_memb;

hta_mema ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Tree a -> HashedTa_ext b a c -> Bool;
hta_mema t h = not (lh_disjoint (faccs h t) (hta_Qi h));

hta_delta :: forall a b c. HashedTa_ext a b c -> Dlist (Ta_rule a b);
hta_delta (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  hta_delta;

hta_idx_f_update ::
  forall a b c.
    (Maybe (Hashmap a (Dlist (Ta_rule b a))) ->
      Maybe (Hashmap a (Dlist (Ta_rule b a)))) ->
      HashedTa_ext b a c -> HashedTa_ext b a c;
hta_idx_f_update hta_idx_fa
  (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  HashedTa_ext hta_Qi hta_delta (hta_idx_fa hta_idx_f) hta_idx_s hta_idx_sf
    more;

idx_build_stepfun ::
  forall a b c d.
    (a -> b -> Maybe c) ->
      (a -> c -> b -> b) ->
        (() -> c) -> (d -> c -> c) -> (d -> a) -> d -> b -> b;
idx_build_stepfun mlookup mupdate tempty tinsert f x m =
  let {
    i = f x;
  } in (case mlookup i m of {
         Nothing -> mupdate i (tinsert x (tempty ())) m;
         Just s -> mupdate i (tinsert x s) m;
       });

idx_build ::
  forall a b c d e.
    (() -> a) ->
      (b -> a -> Maybe c) ->
        (b -> c -> a -> a) ->
          (() -> c) ->
            (d -> c -> c) ->
              (e -> (a -> Bool) -> (d -> a -> a) -> a -> a) ->
                (d -> b) -> e -> a;
idx_build mempty mlookup mupdate tempty tinsert siterate f s =
  siterate s (\ _ -> True) (idx_build_stepfun mlookup mupdate tempty tinsert f)
    (mempty ());

hll_idx_build ::
  forall a b.
    (Eq a, Eq b, Hashable b) => (a -> b) -> Dlist a -> Hashmap b (Dlist a);
hll_idx_build =
  idx_build hm_empty hm_lookup hm_update ls_empty ls_ins ls_iteratei;

build_rule_index ::
  forall a b c.
    (Eq a, Eq b, Eq c,
      Hashable c) => (Ta_rule a b -> c) ->
                       Dlist (Ta_rule a b) -> Hashmap c (Dlist (Ta_rule a b));
build_rule_index = hll_idx_build;

build_rule_index_f ::
  forall a b.
    (Eq a, Eq b,
      Hashable b) => Dlist (Ta_rule a b) -> Hashmap b (Dlist (Ta_rule a b));
build_rule_index_f delta = build_rule_index rhsl delta;

hta_ensure_idx_f ::
  forall a b c.
    (Eq a, Eq b, Hashable b) => HashedTa_ext a b c -> HashedTa_ext a b c;
hta_ensure_idx_f h =
  (case hta_idx_f h of {
    Nothing ->
      hta_idx_f_update (\ _ -> Just (build_rule_index_f (hta_delta h))) h;
    Just _ -> h;
  });

hta_mem ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Tree a -> HashedTa_ext b a c -> Bool;
hta_mem t h = hta_mema t (hta_ensure_idx_f h);

pa_cond ::
  forall a b c.
    (Hashable a, Hashable b,
      Hashable c) => (Hashmap (a, b) (),
                       ([(a, b)], Dlist (Ta_rule (a, b) c))) ->
                       Bool;
pa_cond s = let {
              (_, (w, _)) = s;
            } in not (null w);

hashcode_prod :: forall a b. (Hashable a, Hashable b) => (a, b) -> Nat.Nat;
hashcode_prod x = hashcode (fst x) * 33 + hashcode (snd x);

bounded_hashcode_prod ::
  forall a b. (Hashable a, Hashable b) => Nat.Nat -> (a, b) -> Nat.Nat;
bounded_hashcode_prod n x =
  mod_nat (bounded_hashcode n (fst x) * 33 + bounded_hashcode n (snd x)) n;

def_hashmap_size_prod ::
  forall a b. (Hashable a, Hashable b) => Itself (a, b) -> Nat.Nat;
def_hashmap_size_prod =
  (\ _ ->
    (def_hashmap_size :: Itself a -> Nat.Nat) Type +
      (def_hashmap_size :: Itself b -> Nat.Nat) Type);

instance (Hashable a, Hashable b) => Hashable (a, b) where {
  hashcode = hashcode_prod;
  bounded_hashcode = bounded_hashcode_prod;
  def_hashmap_size = def_hashmap_size_prod;
};

pa_upd_rule ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Hashmap (a, b) () ->
                       [(a, b)] -> [(a, b)] -> (Hashmap (a, b) (), [(a, b)]);
pa_upd_rule q w [] = (q, w);
pa_upd_rule q w (qp : qs) =
  (if not (hs_memb qp q) then pa_upd_rule (hs_ins qp q) (qp : w) qs
    else pa_upd_rule q w qs);

hta_idx_s ::
  forall a b c. HashedTa_ext a b c -> Maybe (Hashmap a (Dlist (Ta_rule a b)));
hta_idx_s (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  hta_idx_s;

hta_lookup_s ::
  forall a b c.
    (Eq a, Hashable a) => a -> HashedTa_ext a b c -> Dlist (Ta_rule a b);
hta_lookup_s q h = hl_idx_lookup q (the (hta_idx_s h));

ls_ins_dj :: forall a. (Eq a) => a -> Dlist a -> Dlist a;
ls_ins_dj = insertb;

hta_idx_sf ::
  forall a b c.
    HashedTa_ext a b c -> Maybe (Hashmap (a, b) (Dlist (Ta_rule a b)));
hta_idx_sf (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  hta_idx_sf;

hta_lookup_sf ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => a -> b -> HashedTa_ext a b c -> Dlist (Ta_rule a b);
hta_lookup_sf q f h = hl_idx_lookup (q, f) (the (hta_idx_sf h));

pa_step ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => HashedTa_ext a b () ->
                       HashedTa_ext c b () ->
                         (Hashmap (a, c) (),
                           ([(a, c)], Dlist (Ta_rule (a, c) b))) ->
                           (Hashmap (a, c) (),
                             ([(a, c)], Dlist (Ta_rule (a, c) b)));
pa_step h1 h2 s =
  let {
    (q, (w, delta_d)) = s;
    (q1, q2) = hd w;
  } in ls_iteratei (hta_lookup_s q1 h1) (\ _ -> True)
         (\ r1 ->
           ls_iteratei (hta_lookup_sf q2 (rhsl r1) h2) (\ _ -> True)
             (\ r2 res ->
               (if size_list (rhsq r1) == size_list (rhsq r2)
                 then let {
                        rp = r_prod r1 r2;
                        (qa, (wa, delta_da)) = res;
                        (qb, wb) = pa_upd_rule qa wa (rhsq rp);
                      } in (qb, (wb, ls_ins_dj rp delta_da))
                 else res)))
         (q, (tl w, delta_d));

map_to_nat ::
  forall a b c.
    (a -> ((Nat.Nat, b) -> Bool) ->
            (c -> (Nat.Nat, b) -> (Nat.Nat, b)) ->
              (Nat.Nat, b) -> (Nat.Nat, b)) ->
      (() -> b) -> (c -> Nat.Nat -> b -> b) -> a -> b;
map_to_nat iterate1 empty2 update2 s =
  snd (iterate1 s (\ _ -> True) (\ x (c, m) -> (c + 1, update2 x c m))
        (0, empty2 ()));

equal_dlist :: forall a. (Eq a) => Dlist a -> Dlist a -> Bool;
equal_dlist dxs dys = list_of_dlist dxs == list_of_dlist dys;

instance (Eq a) => Eq (Dlist a) where {
  a == b = equal_dlist a b;
};

iflt_image :: forall a b c d. ((a -> Maybe b) -> c -> d) -> (a -> b) -> c -> d;
iflt_image iflt f s = iflt (\ x -> Just (f x)) s;

hs_image_filter ::
  forall a b.
    (Hashable a, Eq b,
      Hashable b) => (a -> Maybe b) -> Hashmap a () -> Hashmap b ();
hs_image_filter = it_image_filter hs_iteratei hs_empty hs_ins;

hs_image ::
  forall a b.
    (Hashable a, Eq b, Hashable b) => (a -> b) -> Hashmap a () -> Hashmap b ();
hs_image = iflt_image hs_image_filter;

s_ins_dj :: forall a b c. (a -> () -> b -> c) -> a -> b -> c;
s_ins_dj update_dj x s = update_dj x () s;

hm_update_dj ::
  forall a b. (Eq a, Hashable a) => a -> b -> Hashmap a b -> Hashmap a b;
hm_update_dj = hm_update;

hs_ins_dj :: forall a. (Eq a, Hashable a) => a -> Hashmap a () -> Hashmap a ();
hs_ins_dj = s_ins_dj hm_update_dj;

hs_inter ::
  forall a. (Eq a, Hashable a) => Hashmap a () -> Hashmap a () -> Hashmap a ();
hs_inter = it_inter hs_iteratei hs_memb hs_empty hs_ins_dj;

hs_union ::
  forall a. (Eq a, Hashable a) => Hashmap a () -> Hashmap a () -> Hashmap a ();
hs_union = hm_add;

hhh_cart ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Hashmap a () -> Hashmap b () -> Hashmap (a, b) ();
hhh_cart = cart hs_iteratei hs_iteratei hs_empty hs_ins_dj;

brc_cond ::
  forall a b.
    (Hashable a,
      Hashable b) => (Hashmap a (), ([a], Hashmap (Ta_rule a b) Nat.Nat)) ->
                       Bool;
brc_cond = (\ (_, (w, _)) -> not (null w));

rqrm_lookup ::
  forall a b. (Eq a, Hashable a) => Hashmap a (Dlist b) -> a -> Dlist b;
rqrm_lookup rqrm q =
  (case hm_lookup q rqrm of {
    Nothing -> ls_empty ();
    Just s -> s;
  });

hashcode_list :: forall a. (Hashable a) => [a] -> Nat.Nat;
hashcode_list = foldla (\ h x -> h * 33 + hashcode x) 5381;

hashcode_of_ta_rule ::
  forall a b. (Hashable a, Hashable b) => Ta_rule a b -> Nat.Nat;
hashcode_of_ta_rule (Rule q f qs) = hashcode q + hashcode f + hashcode_list qs;

hashcode_ta_rule ::
  forall a b. (Hashable a, Hashable b) => Ta_rule a b -> Nat.Nat;
hashcode_ta_rule = hashcode_of_ta_rule;

bounded_hashcode_ta_rule ::
  forall a b. (Hashable a, Hashable b) => Nat.Nat -> Ta_rule a b -> Nat.Nat;
bounded_hashcode_ta_rule n r = mod_nat (hashcode_of_ta_rule r) n;

def_hashmap_size_ta_rule ::
  forall a b. (Hashable a, Hashable b) => Itself (Ta_rule a b) -> Nat.Nat;
def_hashmap_size_ta_rule = (\ _ -> 32);

instance (Hashable a, Hashable b) => Hashable (Ta_rule a b) where {
  hashcode = hashcode_ta_rule;
  bounded_hashcode = bounded_hashcode_ta_rule;
  def_hashmap_size = def_hashmap_size_ta_rule;
};

brc_inner_step ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Ta_rule a b ->
                       (Hashmap a (), ([a], Hashmap (Ta_rule a b) Nat.Nat)) ->
                         (Hashmap a (), ([a], Hashmap (Ta_rule a b) Nat.Nat));
brc_inner_step r =
  (\ (q, (w, rcm)) ->
    let {
      c = the (hm_lookup r rcm);
      rcma = hm_update r (c - 1) rcm;
      qa = (if c <= 1 then hs_ins (lhs r) q else q);
      wa = (if c <= 1 && not (hs_memb (lhs r) q) then lhs r : w else w);
    } in (qa, (wa, rcma)));

brc_step ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Hashmap a (Dlist (Ta_rule a b)) ->
                       (Hashmap a (), ([a], Hashmap (Ta_rule a b) Nat.Nat)) ->
                         (Hashmap a (), ([a], Hashmap (Ta_rule a b) Nat.Nat));
brc_step rqrm =
  (\ (q, (w, rcm)) ->
    ls_iteratei (rqrm_lookup rqrm (hd w)) (\ _ -> True) brc_inner_step
      (q, (tl w, rcm)));

brec_iqm ::
  forall a b.
    (Eq a, Hashable a, Hashable b) => Dlist (Ta_rule a b) -> Hashmap a (Tree b);
brec_iqm delta =
  ls_iteratei delta (\ _ -> True)
    (\ r m ->
      (if null (rhsq r) then hm_update (lhs r) (Node (rhsl r) []) m else m))
    (hm_empty ());

init_hta ::
  forall a b. Hashmap a () -> Dlist (Ta_rule a b) -> HashedTa_ext a b ();
init_hta qi delta = HashedTa_ext qi delta Nothing Nothing Nothing ();

it_set_to_list ::
  forall a b.
    (a -> ([b] -> Bool) -> (b -> [b] -> [b]) -> [b] -> [b]) -> a -> [b];
it_set_to_list iti s = iti s (\ _ -> True) (\ a b -> a : b) [];

hs_to_list :: forall a. (Hashable a) => Hashmap a () -> [a];
hs_to_list = it_set_to_list hs_iteratei;

pa_initial ::
  forall a b c.
    (Eq a, Hashable a, Hashable b, Eq c,
      Hashable c) => HashedTa_ext a b () ->
                       HashedTa_ext c b () ->
                         (Hashmap (a, c) (),
                           ([(a, c)], Dlist (Ta_rule (a, c) b)));
pa_initial h1 h2 =
  let {
    qip = hhh_cart (hta_Qi h1) (hta_Qi h2);
  } in (qip, (hs_to_list qip, ls_empty ()));

while_option :: forall a. (a -> Bool) -> (a -> a) -> a -> Maybe a;
while_option b c s = (if b s then while_option b c (c s) else Just s);

while :: forall a. (a -> Bool) -> (a -> a) -> a -> a;
while b c s = the (while_option b c s);

hta_proda ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => HashedTa_ext a b () ->
                       HashedTa_ext c b () -> HashedTa_ext (a, c) b ();
hta_proda h1 h2 =
  let {
    (_, (_, a)) = while pa_cond (pa_step h1 h2) (pa_initial h1 h2);
  } in init_hta (hhh_cart (hta_Qi h1) (hta_Qi h2)) a;

hta_idx_s_update ::
  forall a b c.
    (Maybe (Hashmap a (Dlist (Ta_rule a b))) ->
      Maybe (Hashmap a (Dlist (Ta_rule a b)))) ->
      HashedTa_ext a b c -> HashedTa_ext a b c;
hta_idx_s_update hta_idx_sa
  (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  HashedTa_ext hta_Qi hta_delta hta_idx_f (hta_idx_sa hta_idx_s) hta_idx_sf
    more;

build_rule_index_s ::
  forall a b.
    (Eq a, Hashable a,
      Eq b) => Dlist (Ta_rule a b) -> Hashmap a (Dlist (Ta_rule a b));
build_rule_index_s delta = build_rule_index lhs delta;

hta_ensure_idx_s ::
  forall a b c.
    (Eq a, Hashable a, Eq b) => HashedTa_ext a b c -> HashedTa_ext a b c;
hta_ensure_idx_s h =
  (case hta_idx_s h of {
    Nothing ->
      hta_idx_s_update (\ _ -> Just (build_rule_index_s (hta_delta h))) h;
    Just _ -> h;
  });

hta_idx_sf_update ::
  forall a b c.
    (Maybe (Hashmap (a, b) (Dlist (Ta_rule a b))) ->
      Maybe (Hashmap (a, b) (Dlist (Ta_rule a b)))) ->
      HashedTa_ext a b c -> HashedTa_ext a b c;
hta_idx_sf_update hta_idx_sfa
  (HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more) =
  HashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s (hta_idx_sfa hta_idx_sf)
    more;

build_rule_index_sf ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Dlist (Ta_rule a b) ->
                       Hashmap (a, b) (Dlist (Ta_rule a b));
build_rule_index_sf delta = build_rule_index (\ r -> (lhs r, rhsl r)) delta;

hta_ensure_idx_sf ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext a b c -> HashedTa_ext a b c;
hta_ensure_idx_sf h =
  (case hta_idx_sf h of {
    Nothing ->
      hta_idx_sf_update (\ _ -> Just (build_rule_index_sf (hta_delta h))) h;
    Just _ -> h;
  });

hta_prod ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => HashedTa_ext a b () ->
                       HashedTa_ext c b () -> HashedTa_ext (a, c) b ();
hta_prod h1 h2 = hta_proda (hta_ensure_idx_s h1) (hta_ensure_idx_sf h2);

hashcode_nat :: Nat.Nat -> Nat.Nat;
hashcode_nat n = n;

bounded_hashcode_nat :: Nat.Nat -> Nat.Nat -> Nat.Nat;
bounded_hashcode_nat na n = mod_nat n na;

def_hashmap_size_nat :: Itself Nat.Nat -> Nat.Nat;
def_hashmap_size_nat = (\ _ -> 16);

instance Hashable Nat.Nat where {
  hashcode = hashcode_nat;
  bounded_hashcode = bounded_hashcode_nat;
  def_hashmap_size = def_hashmap_size_nat;
};

htai_mem :: Tree Nat.Nat -> HashedTa_ext Nat.Nat Nat.Nat () -> Bool;
htai_mem = hta_mem;

rqrm_add ::
  forall a b.
    (Eq a, Hashable a,
      Eq b) => a -> b -> Hashmap a (Dlist b) -> Hashmap a (Dlist b);
rqrm_add q r res =
  (case hm_lookup q res of {
    Nothing -> hm_update q (ls_ins r (ls_empty ())) res;
    Just s -> hm_update q (ls_ins r s) res;
  });

fifo_dequeue :: forall a. ([a], [a]) -> (a, ([a], [a]));
fifo_dequeue f =
  (case snd f of {
    [] -> let {
            rp = reverse (fst f);
          } in (hd rp, ([], tl rp));
    a : l -> (a, (fst f, l));
  });

fifo_enqueue :: forall a. a -> ([a], [a]) -> ([a], [a]);
fifo_enqueue a f = (a : fst f, snd f);

fifo_isEmpty :: forall a. (Eq a) => ([a], [a]) -> Bool;
fifo_isEmpty f = f == ([], []);

lhh_union ::
  forall a. (Eq a, Hashable a) => Dlist a -> Hashmap a () -> Hashmap a ();
lhh_union = it_union ls_iteratei hs_ins;

brec_cond ::
  forall a b.
    (Eq a) => (Hashmap a (Tree b),
                (([a], [a]), (Hashmap (Ta_rule a b) Nat.Nat, Maybe a))) ->
                Bool;
brec_cond = (\ (_, (w, (_, qwit))) -> not (fifo_isEmpty w) && is_none qwit);

brec_construct_witness ::
  forall a b.
    (Eq a, Hashable a,
      Hashable b) => Hashmap a (Tree b) -> Ta_rule a b -> Tree b;
brec_construct_witness qm r =
  Node (rhsl r) (map (\ q -> the (hm_lookup q qm)) (rhsq r));

brec_inner_step ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Hashmap a () ->
                       Ta_rule a b ->
                         (Hashmap a (Tree b),
                           (([a], [a]),
                             (Hashmap (Ta_rule a b) Nat.Nat, Maybe a))) ->
                           (Hashmap a (Tree b),
                             (([a], [a]),
                               (Hashmap (Ta_rule a b) Nat.Nat, Maybe a)));
brec_inner_step qi r =
  (\ (q, (w, (rcm, qwit))) ->
    let {
      c = the (hm_lookup r rcm);
      cond = c <= 1 && is_none (hm_lookup (lhs r) q);
      rcma = hm_update r (c - 1) rcm;
      qa = (if cond then hm_update (lhs r) (brec_construct_witness q r) q
             else q);
      wa = (if cond then fifo_enqueue (lhs r) w else w);
      qwita = (if c <= 1 && hs_memb (lhs r) qi then Just (lhs r) else qwit);
    } in (qa, (wa, (rcma, qwita))));

brec_step ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Hashmap a (Dlist (Ta_rule a b)) ->
                       Hashmap a () ->
                         (Hashmap a (Tree b),
                           (([a], [a]),
                             (Hashmap (Ta_rule a b) Nat.Nat, Maybe a))) ->
                           (Hashmap a (Tree b),
                             (([a], [a]),
                               (Hashmap (Ta_rule a b) Nat.Nat, Maybe a)));
brec_step rqrm qi =
  (\ (q, (w, (rcm, qwit))) ->
    let {
      (qa, wa) = fifo_dequeue w;
    } in ls_iteratei (rqrm_lookup rqrm qa) (\ _ -> True) (brec_inner_step qi)
           (q, (wa, (rcm, qwit))));

hta_empty :: forall a b. (Hashable a, Hashable b) => () -> HashedTa_ext a b ();
hta_empty u = init_hta (hs_empty ()) (ls_empty ());

ls_image :: forall a b. (Eq b) => (a -> b) -> Dlist a -> Dlist b;
ls_image = iflt_image ls_image_filter;

hta_remap ::
  forall a b c.
    (Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => (a -> b) -> HashedTa_ext a c () -> HashedTa_ext b c ();
hta_remap f h =
  init_hta (hs_image f (hta_Qi h)) (ls_image (remap_rule f) (hta_delta h));

equal_ustate_wrapper ::
  forall a b. (Eq a, Eq b) => Ustate_wrapper a b -> Ustate_wrapper a b -> Bool;
equal_ustate_wrapper (USW2 q2) (USW1 q1) = False;
equal_ustate_wrapper (USW1 q1) (USW2 q2) = False;
equal_ustate_wrapper (USW2 q2a) (USW2 q2) = q2a == q2;
equal_ustate_wrapper (USW1 q1a) (USW1 q1) = q1a == q1;

instance (Eq a, Eq b) => Eq (Ustate_wrapper a b) where {
  a == b = equal_ustate_wrapper a b;
};

ls_union :: forall a. (Eq a) => Dlist a -> Dlist a -> Dlist a;
ls_union = it_union ls_iteratei ls_ins;

ls_union_dj :: forall a. (Eq a) => Dlist a -> Dlist a -> Dlist a;
ls_union_dj = ls_union;

hashcode_ustate_wrapper ::
  forall a b. (Hashable a, Hashable b) => Ustate_wrapper a b -> Nat.Nat;
hashcode_ustate_wrapper x =
  (case x of {
    USW1 a -> 2 * hashcode a;
    USW2 b -> 2 * hashcode b + 1;
  });

bounded_hashcode_ustate_wrapper ::
  forall a b.
    (Hashable a, Hashable b) => Nat.Nat -> Ustate_wrapper a b -> Nat.Nat;
bounded_hashcode_ustate_wrapper n x =
  (case x of {
    USW1 a -> bounded_hashcode n a;
    USW2 b -> n - 1 - bounded_hashcode n b;
  });

def_hashmap_size_ustate_wrapper ::
  forall a b.
    (Hashable a, Hashable b) => Itself (Ustate_wrapper a b) -> Nat.Nat;
def_hashmap_size_ustate_wrapper =
  (\ _ ->
    (def_hashmap_size :: Itself a -> Nat.Nat) Type +
      (def_hashmap_size :: Itself b -> Nat.Nat) Type);

instance (Hashable a, Hashable b) => Hashable (Ustate_wrapper a b) where {
  hashcode = hashcode_ustate_wrapper;
  bounded_hashcode = bounded_hashcode_ustate_wrapper;
  def_hashmap_size = def_hashmap_size_ustate_wrapper;
};

hta_union ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => HashedTa_ext a b () ->
                       HashedTa_ext c b () ->
                         HashedTa_ext (Ustate_wrapper a c) b ();
hta_union h1 h2 =
  init_hta (hs_union (hs_image USW1 (hta_Qi h1)) (hs_image USW2 (hta_Qi h2)))
    (ls_union_dj (ls_image (remap_rule USW1) (hta_delta h1))
      (ls_image (remap_rule USW2) (hta_delta h2)));

list_to_ls :: forall a. (Eq a) => [a] -> Dlist a;
list_to_ls xs = Dlist (remdups xs);

rule_states_l :: forall a b. (Eq a) => Ta_rule a b -> Dlist a;
rule_states_l (Rule q f qs) = ls_ins q (list_to_ls qs);

it_Union_image ::
  forall a b c d e.
    (a -> (b -> Bool) -> (c -> d -> d) -> d -> d) ->
      (() -> d) -> (e -> d -> d) -> (c -> e) -> a -> d;
it_Union_image iti1 em3 un233 f s =
  iti1 s (\ _ -> True) (\ x -> un233 (f x)) (em3 ());

llh_Union_image ::
  forall a b. (Eq b, Hashable b) => (a -> Dlist b) -> Dlist a -> Hashmap b ();
llh_Union_image = it_Union_image ls_iteratei hs_empty lhh_union;

hta_delta_states ::
  forall a b c. (Eq a, Hashable a) => HashedTa_ext a b c -> Hashmap a ();
hta_delta_states h =
  llh_Union_image id
    (ls_image_filter (\ r -> Just (rule_states_l r)) (hta_delta h));

hta_states ::
  forall a b c. (Eq a, Hashable a) => HashedTa_ext a b c -> Hashmap a ();
hta_states h = hs_union (hta_Qi h) (hta_delta_states h);

hh_map_to_nat ::
  forall a. (Eq a, Hashable a) => Hashmap a () -> Hashmap a Nat.Nat;
hh_map_to_nat = map_to_nat hs_iteratei hm_empty hm_update;

hta_reindex ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext a b () -> HashedTa_ext Nat.Nat b ();
hta_reindex h =
  let {
    mp = hh_map_to_nat (hta_states h);
  } in hta_remap (\ q -> the (hm_lookup q mp)) h;

htai_prod ::
  HashedTa_ext Nat.Nat Nat.Nat () ->
    HashedTa_ext Nat.Nat Nat.Nat () -> HashedTa_ext Nat.Nat Nat.Nat ();
htai_prod h1 h2 = hta_reindex (hta_prod h1 h2);

it_set_to_List_enq ::
  forall a b c.
    (a -> (b -> Bool) -> (c -> b -> b) -> b -> b) ->
      (() -> b) -> (c -> b -> b) -> a -> b;
it_set_to_List_enq iteratea emp enq s = iteratea s (\ _ -> True) enq (emp ());

it_set_to_fifo ::
  forall a b.
    (a -> (([b], [b]) -> Bool) ->
            (b -> ([b], [b]) -> ([b], [b])) -> ([b], [b]) -> ([b], [b])) ->
      a -> ([b], [b]);
it_set_to_fifo it = it_set_to_List_enq it fifo_empty fifo_enqueue;

hs_to_fifo :: forall a. (Hashable a) => Hashmap a () -> ([a], [a]);
hs_to_fifo = it_set_to_fifo hs_iteratei;

build_rqrm ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Dlist (Ta_rule a b) -> Hashmap a (Dlist (Ta_rule a b));
build_rqrm delta =
  ls_iteratei delta (\ _ -> True)
    (\ r res -> foldla (\ resa q -> rqrm_add q r resa) res (rhsq r))
    (hm_empty ());

hta_add_qi ::
  forall a b.
    (Eq a, Hashable a,
      Hashable b) => a -> HashedTa_ext a b () -> HashedTa_ext a b ();
hta_add_qi qi h = init_hta (hs_ins qi (hta_Qi h)) (hta_delta h);

image_filter_cartesian_product ::
  forall a b c d e f.
    (a -> (b -> Bool) -> (c -> b -> b) -> b -> b) ->
      (d -> (b -> Bool) -> (e -> b -> b) -> b -> b) ->
        (() -> b) -> (f -> b -> b) -> ((c, e) -> Maybe f) -> a -> d -> b;
image_filter_cartesian_product iterate1 iterate2 empty3 insert3 f s1 s2 =
  iterate1 s1 (\ _ -> True)
    (\ x ->
      iterate2 s2 (\ _ -> True)
        (\ y res ->
          (case f (x, y) of {
            Nothing -> res;
            Just z -> insert3 z res;
          })))
    (empty3 ());

image_filter_cp ::
  forall a b c d e f.
    (a -> (b -> Bool) -> (c -> b -> b) -> b -> b) ->
      (d -> (b -> Bool) -> (e -> b -> b) -> b -> b) ->
        (() -> b) ->
          (f -> b -> b) -> ((c, e) -> f) -> ((c, e) -> Bool) -> a -> d -> b;
image_filter_cp iterate1 iterate2 empty3 insert3 f p s1 s2 =
  image_filter_cartesian_product iterate1 iterate2 empty3 insert3
    (\ xy -> (if p xy then Just (f xy) else Nothing)) s1 s2;

lll_inj_image_filter_cp ::
  forall a b c.
    (Eq c) => ((a, b) -> c) ->
                ((a, b) -> Bool) -> Dlist a -> Dlist b -> Dlist c;
lll_inj_image_filter_cp =
  image_filter_cp ls_iteratei ls_iteratei ls_empty ls_ins_dj;

delta_prod_h ::
  forall a b c.
    (Eq a, Hashable a, Eq b, Hashable b, Eq c,
      Hashable c) => Dlist (Ta_rule a b) ->
                       Dlist (Ta_rule c b) -> Dlist (Ta_rule (a, c) b);
delta_prod_h delta_1 delta_2 =
  lll_inj_image_filter_cp (\ (a, b) -> r_prod a b)
    (\ (r1, r2) ->
      rhsl r1 == rhsl r2 && size_list (rhsq r1) == size_list (rhsq r2))
    delta_1 delta_2;

hta_prodWR ::
  forall a b c d e.
    (Eq a, Hashable a, Eq b, Hashable b, Eq d,
      Hashable d) => HashedTa_ext a b c ->
                       HashedTa_ext d b e -> HashedTa_ext (a, d) b ();
hta_prodWR h1 h2 =
  init_hta (hhh_cart (hta_Qi h1) (hta_Qi h2))
    (delta_prod_h (hta_delta h1) (hta_delta h2));

hta_reduce ::
  forall a b c.
    (Eq a, Hashable a,
      Eq b) => HashedTa_ext a b c -> Hashmap a () -> HashedTa_ext a b ();
hta_reduce h q =
  init_hta (hs_inter q (hta_Qi h))
    (ls_image_filter
      (\ r ->
        (if hs_memb (lhs r) q && all (\ qa -> hs_memb qa q) (rhsq r) then Just r
          else Nothing))
      (hta_delta h));

htai_empty :: () -> HashedTa_ext Nat.Nat Nat.Nat ();
htai_empty = hta_empty;

htai_union ::
  HashedTa_ext Nat.Nat Nat.Nat () ->
    HashedTa_ext Nat.Nat Nat.Nat () -> HashedTa_ext Nat.Nat Nat.Nat ();
htai_union h1 h2 = hta_reindex (hta_union h1 h2);

brc_rcm_init ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Dlist (Ta_rule a b) -> Hashmap (Ta_rule a b) Nat.Nat;
brc_rcm_init delta =
  ls_iteratei delta (\ _ -> True)
    (\ r -> hm_update r (size_list (remdups (rhsq r)))) (hm_empty ());

brc_initial ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Dlist (Ta_rule a b) ->
                       (Hashmap a (), ([a], Hashmap (Ta_rule a b) Nat.Nat));
brc_initial delta =
  let {
    iq = brc_iq delta;
  } in (iq, (hs_to_list iq, brc_rcm_init delta));

htai_add_qi ::
  Nat.Nat -> HashedTa_ext Nat.Nat Nat.Nat () -> HashedTa_ext Nat.Nat Nat.Nat ();
htai_add_qi = hta_add_qi;

htai_prodWR ::
  HashedTa_ext Nat.Nat Nat.Nat () ->
    HashedTa_ext Nat.Nat Nat.Nat () -> HashedTa_ext Nat.Nat Nat.Nat ();
htai_prodWR h1 h2 = hta_reindex (hta_prodWR h1 h2);

sel_disjoint_witness ::
  forall a b c d. (a -> (b -> Maybe b) -> c) -> (b -> d -> Bool) -> a -> d -> c;
sel_disjoint_witness sel1 mem2 s1 s2 =
  sel1 s1 (\ x -> (if mem2 x s2 then Just x else Nothing));

hh_disjoint_witness ::
  forall a. (Eq a, Hashable a) => Hashmap a () -> Hashmap a () -> Maybe a;
hh_disjoint_witness = sel_disjoint_witness hs_sel hs_memb;

brec_initial ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Hashmap a () ->
                       Dlist (Ta_rule a b) ->
                         (Hashmap a (Tree b),
                           (([a], [a]),
                             (Hashmap (Ta_rule a b) Nat.Nat, Maybe a)));
brec_initial qi delta =
  let {
    iq = brc_iq delta;
  } in (brec_iqm delta,
         (hs_to_fifo iq, (brc_rcm_init delta, hh_disjoint_witness iq qi)));

hta_add_rule ::
  forall a b.
    (Eq a, Hashable a, Eq b,
      Hashable b) => Ta_rule a b -> HashedTa_ext a b () -> HashedTa_ext a b ();
hta_add_rule r h = init_hta (hta_Qi h) (ls_ins r (hta_delta h));

htai_add_rule ::
  Ta_rule Nat.Nat Nat.Nat ->
    HashedTa_ext Nat.Nat Nat.Nat () -> HashedTa_ext Nat.Nat Nat.Nat ();
htai_add_rule = hta_add_rule;

hta_bwd_reduce ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext a b c -> HashedTa_ext a b ();
hta_bwd_reduce h =
  let {
    rqrm = build_rqrm (hta_delta h);
  } in hta_reduce h
         (fst (while brc_cond (brc_step rqrm) (brc_initial (hta_delta h))));

htai_bwd_reduce ::
  HashedTa_ext Nat.Nat Nat.Nat () -> HashedTa_ext Nat.Nat Nat.Nat ();
htai_bwd_reduce = hta_bwd_reduce;

htai_ensure_idx_f ::
  HashedTa_ext Nat.Nat Nat.Nat () -> HashedTa_ext Nat.Nat Nat.Nat ();
htai_ensure_idx_f = hta_ensure_idx_f;

htai_ensure_idx_s ::
  HashedTa_ext Nat.Nat Nat.Nat () -> HashedTa_ext Nat.Nat Nat.Nat ();
htai_ensure_idx_s = hta_ensure_idx_s;

htai_ensure_idx_sf ::
  HashedTa_ext Nat.Nat Nat.Nat () -> HashedTa_ext Nat.Nat Nat.Nat ();
htai_ensure_idx_sf = hta_ensure_idx_sf;

hta_is_empty_witness ::
  forall a b c.
    (Eq a, Hashable a, Eq b,
      Hashable b) => HashedTa_ext a b c -> Maybe (Tree b);
hta_is_empty_witness h =
  let {
    rqrm = build_rqrm (hta_delta h);
  } in (case while brec_cond (brec_step rqrm (hta_Qi h))
               (brec_initial (hta_Qi h) (hta_delta h))
         of {
         (q, (_, (_, Nothing))) -> Nothing;
         (q, (_, (_, Just qa))) -> hm_lookup qa q;
       });

htai_is_empty_witness ::
  HashedTa_ext Nat.Nat Nat.Nat () -> Maybe (Tree Nat.Nat);
htai_is_empty_witness = hta_is_empty_witness;

}
